#include <iostream>
#include <mpi.h>

using namespace std;

int main(int argc, char *argv[]) {

   // initialize MPI and get rank and size
   MPI_Init(&argc, &argv);
  
   int rank, size;
   MPI_Comm_rank(MPI_COMM_WORLD, &rank);
   MPI_Comm_size(MPI_COMM_WORLD, &size);

   // generate data on all processes
   int my_val     = rank+1;
   int global_sum = 0;   

   // wait for all processes and start timing
   MPI_Barrier(MPI_COMM_WORLD);
   double wtime = MPI_Wtime();
   
   // implement communication to sum all my_val to global_sum on root
   // ToDo: insert your code here

   // complete timing
   wtime = MPI_Wtime()-wtime;

   // output of final result
   if (rank==0) {
     cout << "global_sum = " << global_sum
          << " (should be = " << size*(size+1)/2 << ")" << endl;
     cout << "took " << wtime << " seconds to compute!" << endl;
   }

   // finalize MPI
   MPI_Finalize();
}
